> For the complete documentation index, see [llms.txt](https://docs.zama.org/concrete-ml/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zama.org/concrete-ml/1.1/developer-guide/api/concrete.ml.common.debugging.custom_assert.md).

# concrete.ml.common.debugging.custom\_assert.md

[![](https://img.shields.io/badge/-source-cccccc?style=flat-square)](https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/src/concrete/ml/common/debugging/custom_assert.py#L0)

## module `concrete.ml.common.debugging.custom_assert`

Provide some variants of assert.

***

[![](https://img.shields.io/badge/-source-cccccc?style=flat-square)](https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/src/concrete/ml/common/debugging/custom_assert.py#L28)

### function `assert_true`

```python
assert_true(
    condition: bool,
    on_error_msg: str = '',
    error_type: Type[Exception] = <class 'AssertionError'>
)
```

Provide a custom assert to check that the condition is True.

**Args:**

* `condition` (bool): the condition. If False, raise AssertionError
* `on_error_msg` (str): optional message for precising the error, in case of error
* `error_type` (Type\[Exception]): the type of error to raise, if condition is not fulfilled. Default to AssertionError

***

[![](https://img.shields.io/badge/-source-cccccc?style=flat-square)](https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/src/concrete/ml/common/debugging/custom_assert.py#L43)

### function `assert_false`

```python
assert_false(
    condition: bool,
    on_error_msg: str = '',
    error_type: Type[Exception] = <class 'AssertionError'>
)
```

Provide a custom assert to check that the condition is False.

**Args:**

* `condition` (bool): the condition. If True, raise AssertionError
* `on_error_msg` (str): optional message for precising the error, in case of error
* `error_type` (Type\[Exception]): the type of error to raise, if condition is not fulfilled. Default to AssertionError

***

[![](https://img.shields.io/badge/-source-cccccc?style=flat-square)](https://github.com/zama-ai/concrete-ml/blob/release/1.1.x/src/concrete/ml/common/debugging/custom_assert.py#L58)

### function `assert_not_reached`

```python
assert_not_reached(
    on_error_msg: str,
    error_type: Type[Exception] = <class 'AssertionError'>
)
```

Provide a custom assert to check that a piece of code is never reached.

**Args:**

* `on_error_msg` (str): message for precising the error
* `error_type` (Type\[Exception]): the type of error to raise, if condition is not fulfilled. Default to AssertionError


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zama.org/concrete-ml/1.1/developer-guide/api/concrete.ml.common.debugging.custom_assert.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
